import ToastComponent from './vue-toast.vue';

//1)vue插件，都必须有install方法
let Toast = {};
Toast.install = function (Vue, options) {
    let opt = {
        duration: 3000
    };
    for (let key in options) {
        opt[key] = options[key];
    }
    Vue.prototype.$toast = function (message, option) {
        if (typeof option === 'object') {
            for (let key in option) {
                opt[key] = option[key];
            }
        }
        //1:继承vue组件，拿到一个新组件
        const ToastController = Vue.extend(ToastComponent);
        //2：new Vue实例，挂在到新创建的div上；
        let instance = new ToastController().$mount(document.createElement('div'));
        instance.message = message;
        instance.visible = true;
        document.body.appendChild(instance.$el);
        //三秒之后隐藏
        setTimeout(function () {
            instance.visible = false;
            document.body.removeChild(instance.$el); //移除div对象
        }, 3000)
    };
    Vue.prototype.$toast['show'] = function (message, option) {
        Vue.prototype.$toast(message, option)
    };
    Vue.prototype.$toast['success'] = function (message, option) {
        Vue.prototype.$toast(message, option)
    };
    Vue.prototype.$toast['info'] = function (message, option) {
        Vue.prototype.$toast(message, option)
    };
    Vue.prototype.$toast['error'] = function (message, option) {
        Vue.prototype.$toast(message, option)
    };
};
if(window.Vue){
    Vue.use(Toast)
}
export default Toast;